declare type Trim<S extends string> = S extends `${infer T} ` ? Trim<T> : S extends ` ${infer T}` ? Trim<T> : S;
declare type Combinators = ' ' | '>' | '~' | '+';
declare type Split<S, R = never> = S extends `${infer Left},${infer Right}` ? Split<Right, R | Left> : R | S;
declare type Preprocess<I extends string> = I extends `${infer L}, ${infer R}` ? Preprocess<`${L},${R}`> : Trim<I>;
declare type Postprocess<I> = I extends `${infer Tag}.${infer _}` ? Postprocess<Tag> : I extends `${infer Tag}#${infer _}` ? Postprocess<Tag> : I extends `${infer Tag}[${infer _}` ? Postprocess<Tag> : I;
export declare type ParseSelector<I extends string> = string extends I ? Element : Preprocess<I> extends infer I ? I extends `${infer _}${Combinators}${infer Right}` ? ParseSelector<Right> : Split<I> extends infer Tags ? Postprocess<Tags> extends infer Tags ? Tags extends keyof HTMLElementTagNameMap ? HTMLElementTagNameMap[Tags] : Tags extends keyof SVGElementTagNameMap ? SVGElementTagNameMap[Tags] : Element : never : never : never;
export declare function querySelector<S extends string, E extends Element = ParseSelector<S>>(selector: S, element?: Element | Document): E | null;
export declare function querySelectorAll<S extends string, E extends Element = ParseSelector<S>>(selector: S, element?: Element | Document): NodeListOf<E>;
export {};
//# sourceMappingURL=mod.d.ts.map